﻿using IDTechSDK;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace USDKDemo
{
    public partial class ZSDK_Form : Form
    {
        ZmqConfig config = null;
        public ZSDK_Form()
        {
            InitializeComponent();
            config = ZmqConfig.GetConfig();
            if (config == null)
            {
                config = new ZmqConfig();
            }
            if (config.PaeServerPath == null) { config.PaeServerPath = ""; }
            if (config.ZmqServerAddress == null) { config.ZmqServerAddress = ""; }
            if (config.ZmqServerAddress == null) { config.ZmqServerAddress = ""; }
            enableZSDK.Checked = config.EnableZMQ;
            ipBox.Text = config.ZmqServerAddress;
            useWebSockets.Checked = config.UseWebsockets;
            runZSDK.Checked = config.UseZmqServer;
            zsdkPath.Text = config.ZmqServerPath;
            runPAE.Checked = config.UsePaeServer;
            paePath.Text = config.PaeServerPath;

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void useWebSockets_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void enableZSDK_CheckedChanged(object sender, EventArgs e)
        {
            ipLabel.Enabled = enableZSDK.Checked;
            ipBox.Enabled = enableZSDK.Checked;
        }

        private void runZSDK_CheckedChanged(object sender, EventArgs e)
        {
            zsdkButton.Enabled = enableZSDK.Checked;
            zsdkPath.Enabled = enableZSDK.Checked;
        }

        private void runPAE_CheckedChanged(object sender, EventArgs e)
        {
            paebutton.Enabled = runPAE.Checked;
            paePath.Enabled = runPAE.Checked;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            config.EnableZMQ = enableZSDK.Checked;
            config.ZmqServerAddress = ipBox.Text;
            config.UseWebsockets = useWebSockets.Checked;
            config.UseZmqServer =  runZSDK.Checked;
            config.ZmqServerPath = zsdkPath.Text;
            config.UsePaeServer = runPAE.Checked;
            config.PaeServerPath = paePath.Text;
            ZmqConfig.setConfig(config);
            this.Close();
        }

        private void zsdkButton_Click(object sender, EventArgs e)
        {
           if (!string.IsNullOrEmpty(zsdkPath.Text)) openFileDialog1.InitialDirectory = System.IO.Path.GetDirectoryName(zsdkPath.Text);
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                zsdkPath.Text = openFileDialog1.FileName;
            }
        }

        private void paebutton_Click(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(paePath.Text)) openFileDialog1.InitialDirectory = System.IO.Path.GetDirectoryName(paePath.Text);
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                paePath.Text = openFileDialog1.FileName;
            }
        }
    }
}
